% EMAXFLOW_MEX Energy minimization with submodular functions.
%
% Synopsis:
%   x = emaxflow_mex(E,Q,G)
%
% Description:
%   This functions finds a global minimum of the energy function
%      F(x) =  sum  Q(x(t),t) + sum   G(x(E(1,e),x(E(2,e)),e)
%            t=1:nV             e=1:nE
%
%   where all G(:,:,e) must be submodular functions.
%
% Input: 
%   E [2 x nE] int32 -- edges of the graph (0-based index)
%   Q [2 x nV] int32 -- univariate functions
%   G [2 x 2 x nE] int32 -- pairwise functions
%
% Output:
%   x [nV x 1] int32 - optimal solution (0-based)
